 /*****************************************************************************
 * Description        : CiA402 [VvOTv   TCNbNʒu[h
 * Software           : INtime 6.4 + RSI-ECAT 4.2.0
 * Data, Writer       :                                  2023/08/21 : okamoto
 \*****************************************************************************/
 #include <stdio.h>
 #include <string.h>
 #include <rt.h>
 #include <EhApi.h>

//Proccess Image mapping
//---------------------------------------------------
// PI/IN:
//	+00:Statusword				(6041h:00)
//	+02:Position Actual Value	(6064h:00)
// PI/OUT:
//	+00:Controlword				(6040h:00)
//	+02:Target potion			(607Ah:00)
//	+0C:Modes of operation		(6060h:00)
//

 /*****************************************************************************
 * Description : CiA402 T[{hCoԑJڏ
 \*****************************************************************************/
 WORD   fnChgMotionGoState(WORD woStWd, WORD *pCrWd)
 {
    switch( (0x6F & woStWd) ) {
    case    0: *pCrWd = (0xFF70 & *pCrWd) | 0;    break; //    @  -> v
    case 0x40: *pCrWd =                     0x06; break; //  @  -> HdOFFv
    case 0x60: *pCrWd = (0xFF70 & *pCrWd) | 0x06; break; //  @  -> HdOFFv
    case 0x21: *pCrWd = (0xFF70 & *pCrWd) | 0x07; break; // HdOFF  -> T[{fBv
    case 0x23: *pCrWd = (0xFF70 & *pCrWd) | 0x0F; break; // T[{fB   -> T[{ONv
    case 0x27:                                    break; // T[{ON (^]JnOK)
    case 0x2F:                                    break; // ُ폈쒆
    case 0x28: *pCrWd = (0xFF70 & *pCrWd) | 0x80; break; // ُ           -> v
    }
    return (0x6F & woStWd);
 }
 /*****************************************************************************
 * Description : CiA402 T[{hCoԑJڏiԂ֖߂j
 \*****************************************************************************/
  WORD   fnChgMotionInitState(WORD woStWd, WORD *pCrWd)
 {
    switch( (0x6F & woStWd) ) {
    case    0:                                    break; //    ()
    case 0x40:                                    break; //  ()
    case 0x60:                                    break; //  ()
    case 0x21: *pCrWd = (0xFF70 & *pCrWd) | 0x00; break; // HdOFF  -> 
    case 0x23: *pCrWd = (0xFF70 & *pCrWd) | 0x06; break; // T[{fB   -> HdOFF
    case 0x27: *pCrWd = (0xFF70 & *pCrWd) | 0x07; break; // T[{ON       -> T[{fBv
    case 0x2F:                                    break; // ُ폈쒆
    case 0x28: *pCrWd = (0xFF70 & *pCrWd) | 0x80; break; // ُ           -> v
    }
    return (0x6F & woStWd);
 }

 /*****************************************************************************
 * Description : main 
 \*****************************************************************************/
 void   main(int argc, char* argv[])
 {
	WORD			woStatus;
	WORD			woReqState = 0;
	WORD			woNowState = 0;
	EHHANDLE		hAPI;
	BYTE			byModeVal;
    WORD			woStatusWord;	
    WORD			woControlWord;
    DWORD			dwTargetPos = 0;
    DWORD			dwInitPos = 0;
    SLAVE_DETAIL    stSlave;
	
	// <<<< EtherCATOPEN >>>>
	//------------------------------------------------------
    // RSI-ECAT Nԃ`FbN (RSI-ECAT API R[)
    woStatus = EhGetEhNodeStatus("NodeA", 100);
    if( 0 != woStatus ) {
        printf("start check failed\n");
        return ;
    }
    // RSI-ECAT APIΘbnhOPEN (RSI-ECAT API R[)
    hAPI = EhOpen("NodeA", &woStatus);
    if( 0 != woStatus ) {
        printf("EH Handle Open failed\n");
        return ;
    }

	
	// <<<<  >>>>
	//------------------------------------------------------
    // MasterXe[g`FWv (RSI-ECAT API R[)
    // MST_OPERATIONAL : Iy[Vi֑J
    woStatus = EhRqState(hAPI, MST_OPERATIONAL);
    if( 0 != woStatus ) {
		printf("EhRqState() failed. Status = %04xH\n", woStatus);
		return ;
    }

    // Iy[Vi֑Jڂǂ̊mF
    while(1) {
		// ݂ MasterXe[gԎ擾 (RSI-ECAT API R[)
		woStatus = EhGetState(hAPI, &woReqState, &woNowState);
        
		// Iy[Vi֑Jڊ`FbN
		if( woNowState == MST_OPERATIONAL ) {
			break; // Jڊ̈׃uCN
		}

		// Xe[g`FWҋ@pX[v
		RtSleep(500);
    }

    // X[u
    memset(&stSlave, 0, sizeof(stSlave));
    stSlave.dwSize        = sizeof(stSlave);	// Ӂ K\̃TCYw肷Kv܂B
    stSlave.dwVendorID    = 0x0B07;
    stSlave.dwProductCode = 0x2001;
    stSlave.dwInstance    = 0;
    woStatus = EhFindSlave(hAPI, &stSlave);
    if( 0 != woStatus ) {
        printf("EhFindSlave() failed. Status = %04xH\n", woStatus);
        return ;
    }

    // CiA402 샂[h̕ύX
    // 8 : TCNbNʒu[h ֕ύXv
    byModeVal = 8;
    woStatus = EhWriteByte(hAPI, stSlave.dwViosOutBaseOffset + 12, byModeVal);	// write to Modes of operation
    if( 0 != woStatus ) {
        printf("EhWriteODByAlias() failed. Status = %04xH\n", woStatus);
        return ;
    }

	// ڕWʒu݈ʒuōXV
	dwInitPos = EhReadDword(hAPI, stSlave.dwViosInBaseOffset + 2, &woStatus);	// ݈ʒu̎擾
	woStatus  = EhWriteDword(hAPI, stSlave.dwViosOutBaseOffset + 2, dwInitPos);	// w߈ʒu̍XV
	if( 0 != woStatus ) {
        printf("Target Position Initialization failed. Status = %04xH\n", woStatus);
        return ;
    }
	dwTargetPos = dwInitPos;

	
	// <<<< T[{ONԂ֑J >>>>
	//------------------------------------------------------
    // CiA402 T[{hCoԂAT[{ONɑJ
    while(1) {
        woControlWord = 0;

        // TCNbN҂
        woStatus = EhWaitForCyclic(hAPI, WAIT_FOREVER);
        if( 0 != woStatus ) {
            break;  // TCNbNfꂽׁAI
        }

        // ݂̃T[{hCoԎ擾 (RSI-ECAT API R[)
        woStatusWord = EhReadWord(hAPI, stSlave.dwViosInBaseOffset, &woStatus);	// read from StatusWord
        if( 0 != woStatus ) {
            printf("EhReadWord() failed. Status = %04xH\n", woStatus);
            return ;
        }

        // ݂̃T[{hCoԂÃT[{hCoԂ֑Jڂ֐R[
        woStatus = fnChgMotionGoState(woStatusWord, &woControlWord);
        if( woStatus == 0x27 ) {
            break;
        }

        // ̃T[{hCoJڒl (RSI-ECAT API R[)
        woStatus = EhWriteWord(hAPI, stSlave.dwViosOutBaseOffset, woControlWord);	// write to ControlWord
        if( 0 != woStatus ) {
            printf("EhWriteWord() failed. Status = %04xH\n", woStatus);
            return ;
        }
    }

	// <<<< ʒuߐ̎s >>>>
	//------------------------------------------------------
    while(1) 
	{
        // TCNbN҂
        woStatus = EhWaitForCyclic(hAPI, WAIT_FOREVER);
        if( 0 != woStatus ) {
            break;  // TCNbNfꂽׁAI
        }

        // [v1pulseړv(g̃T[{[^̕\ɉĒlݒ肵ĂB)
        EhWriteDword(hAPI, stSlave.dwViosOutBaseOffset + 2, dwTargetPos);	// write to Target position

        dwTargetPos += 4;

		// ڕWʒuB̊mF
		if(dwTargetPos > 16000 + dwInitPos){	// ʒu16000pulseړmF
            break;
        }
    }

		
	// <<<< T[{OFFԂ֑J >>>>
	//------------------------------------------------------
	// CiA402 T[{hCoԂAԂɖ߂
    while(1) {
        woControlWord = 0;

        // TCNbN҂
        woStatus = EhWaitForCyclic(hAPI, WAIT_FOREVER);
        if( 0 != woStatus ) {
            break;  // TCNbNfꂽׁAI
        }

        // ݂̃T[{hCoԎ擾 (RSI-ECAT API R[)
        woStatusWord = EhReadWord(hAPI, stSlave.dwViosInBaseOffset + 0x00, &woStatus);	// read from StatusWord
        if( 0 != woStatus ) {
            printf("EhReadWord() failed. Status = %04xH\n", woStatus);
            return ;
        }

        // ݂̃T[{hCoԂÃT[{hCoԂ֑Jڂ֐R[
        woStatus = fnChgMotionInitState(woStatusWord, &woControlWord);
        if( (woStatus & 0x21) == 0x21 ) {		// Ԃւ̑JڕsṽX[üׁAdHOFF̊mFOKƂB
            break;
        }

        // ̃T[{hCoJڒl (RSI-ECAT API R[)
        woStatus = EhWriteWord(hAPI, stSlave.dwViosOutBaseOffset + 0x00, woControlWord);	// write to ControlWord
        if( 0 != woStatus ) {
            printf("EhWriteWord() failed. Status = %04xH\n", woStatus);
            return ;
        }
    }


	// <<<< EtherCATCLOSE >>>>
	//------------------------------------------------------
	EhClose(hAPI);

    printf("program end.");
 }