 /*****************************************************************************
 * Description        : CiA402 [VvOTv   vt@C|WV[h
 * Software           : INtime 6.4 + RSI-ECAT 4.2.0
 * Data, Writer       :                                  2023/08/21 : okamoto
 \*****************************************************************************/
 #include <stdio.h>
 #include <string.h>
 #include <rt.h>
 #include <EhApi.h>

//Proccess Image mapping
//---------------------------------------------------
// PI/IN:
//	+00:Statusword				(6041h:00)
// PI/OUT:
//	+00:Controlword				(6040h:00)
//	+02:Target position			(607Ah:00)
//	+06:Profile velocty			(6081h:00)
//	+0A:Physical outputs	    (60FEh:01)
//	+0E:Modes of operation		(6060h:00)
//

 /*****************************************************************************
 * Description : CiA402 T[{hCoԑJڏ
 \*****************************************************************************/
 WORD   fnChgMotionGoState(WORD woStWd, WORD *pCrWd)
 {
    switch( (0x6F & woStWd) ) {
    case    0: *pCrWd = (0xFF70 & *pCrWd) | 0;    break; //    @  -> v
    case 0x40: *pCrWd =                     0x06; break; //  @  -> HdOFFv
    case 0x60: *pCrWd = (0xFF70 & *pCrWd) | 0x06; break; //  @  -> HdOFFv
    case 0x21: *pCrWd = (0xFF70 & *pCrWd) | 0x07; break; // HdOFF  -> T[{fBv
    case 0x23: *pCrWd = (0xFF70 & *pCrWd) | 0x0F; break; // T[{fB   -> T[{ONv
    case 0x27:                                    break; // T[{ON (^]JnOK)
    case 0x2F:                                    break; // ُ폈쒆
    case 0x28: *pCrWd = (0xFF70 & *pCrWd) | 0x80; break; // ُ           -> v
    }
    return (0x6F & woStWd);
 }
 /*****************************************************************************
 * Description : CiA402 T[{hCoԑJڏiԂ֖߂j
 \*****************************************************************************/
  WORD   fnChgMotionInitState(WORD woStWd, WORD *pCrWd)
 {
    switch( (0x6F & woStWd) ) {
    case    0:                                    break; //    ()
    case 0x40:                                    break; //  ()
    case 0x60:                                    break; //  ()
    case 0x21: *pCrWd = (0xFF70 & *pCrWd) | 0x00; break; // HdOFF  -> 
    case 0x23: *pCrWd = (0xFF70 & *pCrWd) | 0x06; break; // T[{fB   -> HdOFF
    case 0x27: *pCrWd = (0xFF70 & *pCrWd) | 0x07; break; // T[{ON       -> T[{fBv
    case 0x2F:                                    break; // ُ폈쒆
    case 0x28: *pCrWd = (0xFF70 & *pCrWd) | 0x80; break; // ُ           -> v
    }
    return (0x6F & woStWd);
 }

 /*****************************************************************************
 * Description : main 
 \*****************************************************************************/
 void   main(int argc, char* argv[])
 {
	WORD			woStatus;
	WORD			woReqState = 0;
	WORD			woNowState = 0;
	EHHANDLE		hAPI;
	BYTE			byModeVal;
    WORD			woStatusWord;	
    WORD			woControlWord;
    SLAVE_DETAIL    stSlave;
	

	// <<<< EtherCATOPEN >>>>
	//------------------------------------------------------
    // RSI-ECAT Nԃ`FbN (RSI-ECAT API R[)
    woStatus = EhGetEhNodeStatus("NodeA", 100);
    if( 0 != woStatus ) {
        printf("start check failed\n");
        return ;
    }
    // RSI-ECAT APIΘbnhOPEN (RSI-ECAT API R[)
    hAPI = EhOpen("NodeA", &woStatus);
    if( 0 != woStatus ) {
        printf("EH Handle Open failed\n");
        return ;
    }


	// <<<<  >>>>
	//------------------------------------------------------
    // MasterXe[g`FWv (RSI-ECAT API R[)
    // MST_OPERATIONAL : Iy[Vi֑J
    woStatus = EhRqState(hAPI, MST_OPERATIONAL);
    if( 0 != woStatus ) {
		printf("EhRqState() failed. Status = %04xH\n", woStatus);
		return ;
    }
    // Iy[Vi֑Jڂǂ̊mF
    while(1) {
		// ݂ MasterXe[gԎ擾 (RSI-ECAT API R[)
		woStatus = EhGetState(hAPI, &woReqState, &woNowState);
        
		// Iy[Vi֑Jڊ`FbN
		if( woNowState == MST_OPERATIONAL ) {
			break; // Jڊ̈׃uCN
		}

		// Xe[g`FWҋ@pX[v
		RtSleep(500);
    }

    // X[u
    memset(&stSlave, 0, sizeof(stSlave));
    stSlave.dwSize        = sizeof(stSlave);	// Ӂ K\̃TCYw肷Kv܂B
    stSlave.dwVendorID    = 0x0B07;
    stSlave.dwProductCode = 0x2001;
    stSlave.dwInstance    = 0;
    woStatus = EhFindSlave(hAPI, &stSlave);
    if( 0 != woStatus ) {
        printf("EhFindSlave() failed. Status = %04xH\n", woStatus);
        return ;
    }

    // CiA402 샂[h̕ύX
    // 1 : vt@C|WV[h ֕ύXv
    byModeVal = 1;
    woStatus = EhWriteByte(hAPI, stSlave.dwViosOutBaseOffset + 0x0E, byModeVal);	// write to Modes of operation
    if( 0 != woStatus ) {
        printf("EhWriteODByAlias() failed. Status = %04xH\n", woStatus);
        return ;
    }


	// <<<< T[{ONԂ֑J >>>>
	//------------------------------------------------------
    // CiA402 T[{hCoԂAT[{ONɑJ
    while(1) {
        woControlWord = 0;

        // TCNbN҂
        woStatus = EhWaitForCyclic(hAPI, WAIT_FOREVER);
        if( 0 != woStatus ) {
            break;  // TCNbNfꂽׁAI
        }

        // ݂̃T[{hCoԎ擾 (RSI-ECAT API R[)
        woStatusWord = EhReadWord(hAPI, stSlave.dwViosInBaseOffset + 0x00, &woStatus);	// read from StatusWord
        if( 0 != woStatus ) {
            printf("EhReadWord() failed. Status = %04xH\n", woStatus);
            return ;
        }

        // ݂̃T[{hCoԂÃT[{hCoԂ֑Jڂ֐R[
        woStatus = fnChgMotionGoState(woStatusWord, &woControlWord);
        if( woStatus == 0x27 ) {
            break;
        }

        // ̃T[{hCoJڒl (RSI-ECAT API R[)
        woStatus = EhWriteWord(hAPI, stSlave.dwViosOutBaseOffset + 0x00, woControlWord);	// write to ControlWord
        if( 0 != woStatus ) {
            printf("EhWriteWord() failed. Status = %04xH\n", woStatus);
            return ;
        }
    }


	// <<<< ʒuߐ̎s >>>>
	//------------------------------------------------------
	// ʒuߐ̓o^  g̃T[{[^̕\ɉĒlݒ肵ĂB
	woStatus = 0;
	woStatus |= EhWriteDword(hAPI, stSlave.dwViosOutBaseOffset + 0x02, 16000);	// <TODO> ڕWʒũZbg write to Target position		
	woStatus |= EhWriteDword(hAPI, stSlave.dwViosOutBaseOffset + 0x06,  8000);	// <TODO> ڕWx̃Zbg write to Profile velocty		
    if( 0 != woStatus ) {
        printf("EhWriteDword() failed. Status = %04xH\n", woStatus);
        return ;
	}
    // Controlwordւ̐ݒlZ
	woControlWord = EhReadbackWord(hAPI, stSlave.dwViosOutBaseOffset + 0x00, &woStatus); // ݒl̓ǂݍ read from ControlWord
	    if( 0 != woStatus ) {
        printf("EhWriteDword() failed. Status = %04xH\n", woStatus);
        return ;
	}
	woControlWord |= 0x0010;	// bit4:New Set-PointON
	woControlWord |= 0x0040;	// bit6:RelativeON

	// ʒuߐi΍Wnj̊Jn 
	woStatus = EhWriteWord(hAPI, stSlave.dwViosOutBaseOffset + 0x00, woControlWord);	//  write to ControlWord
    if( 0 != woStatus ) {
        printf("EhWriteWord() failed. Status = %04xH\n", woStatus);
        return ;
	}

	// X[uŎwߎ󂯎̊mF
    while(1) 
	{
        // TCNbN҂
        woStatus = EhWaitForCyclic(hAPI, WAIT_FOREVER);
        if( 0 != woStatus ) {
            break;  // TCNbNfꂽׁAI
        }

		// ݒl̓ǂݍ
		woStatusWord = EhReadWord(hAPI, stSlave.dwViosInBaseOffset + 0x00, &woStatus);	// read from StatusWord
		// BmF
		if((woStatusWord & 0x1000) == 0x1000)	// bit12:Set-Point AcknowledgeONł邩mF
		{
			// [B]
			break;
		}
    }


	// <<<< ڕWʒuB̑ҋ@ >>>>
	//------------------------------------------------------
    while(1) 
	{
        // TCNbN҂
        woStatus = EhWaitForCyclic(hAPI, WAIT_FOREVER);
        if( 0 != woStatus ) {
            break;  // TCNbNfꂽׁAI
        }

		// ݒl̓ǂݍ
		woStatusWord = EhReadWord(hAPI, stSlave.dwViosInBaseOffset + 0x00, &woStatus);	// read from StatusWord

		// BmF
		if((woStatusWord & 0x0400) == 0x0400)	// bit10:Target reachedONł邩mF
		{
			// [B]
			break;
		}
    }
	
	
	// <<<< ڕWʒuB̑ҋ@ >>>>
	//------------------------------------------------------
	// Controlword: New Set-PointOFF
	woControlWord &= (~0x0010); // bit4:New Set-PointOFF
	woStatus = EhWriteWord(hAPI, stSlave.dwViosOutBaseOffset + 0x00, woControlWord);	//  write to ControlWord
    if( 0 != woStatus ) {
        printf("EhWriteWord() failed. Status = %04xH\n", woStatus);
        return ;
	}

	
	// <<<< T[{OFFԂ֑J >>>>
	//------------------------------------------------------
	// CiA402 T[{hCoԂAԂɖ߂
    while(1) {
        woControlWord = 0;

        // TCNbN҂
        woStatus = EhWaitForCyclic(hAPI, WAIT_FOREVER);
        if( 0 != woStatus ) {
            break;  // TCNbNfꂽׁAI
        }

        // ݂̃T[{hCoԎ擾 (RSI-ECAT API R[)
        woStatusWord = EhReadWord(hAPI, stSlave.dwViosInBaseOffset + 0x00, &woStatus);	// read from StatusWord
        if( 0 != woStatus ) {
            printf("EhReadWord() failed. Status = %04xH\n", woStatus);
            return ;
        }

        // ݂̃T[{hCoԂÃT[{hCoԂ֑Jڂ֐R[
        woStatus = fnChgMotionInitState(woStatusWord, &woControlWord);
        if( (woStatus & 0x21) == 0x21 ) {
            break;
        }

        // ̃T[{hCoJڒl (RSI-ECAT API R[)
        woStatus = EhWriteWord(hAPI, stSlave.dwViosOutBaseOffset + 0x00, woControlWord);	// write to ControlWord
        if( 0 != woStatus ) {
            printf("EhWriteWord() failed. Status = %04xH\n", woStatus);
            return ;
        }
    }


	// <<<< EtherCATCLOSE >>>>
	//------------------------------------------------------
	EhClose(hAPI);
    printf("program end.");
 }